import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;
import java.math.*;

/**This is a special class which gathers together like terms
   in polynomials.*/


public class CompressPoly {


    public static Poly6 main(Poly6 P) {
	BigInteger ZERO=new BigInteger("0");
	Poly6 Q=sum(P);
	Poly6 R=new Poly6();
	int c=0;
	for(int i=0;i<Q.count;++i) {
	    if(Q.m[i].c.compareTo(ZERO)!=0) {
		R.m[c]=new Mono6(Q.m[i]);
		++c;
	    }
	}
	R.count=c;
	return(R);
    }

    public static Poly6 sum(Poly6 P) {
	int[][] LIST=coeffList(P);
	Poly6 Q=new Poly6();
	Q.count=LIST.length;
	for(int i=0;i<LIST.length;++i) {
	    Q.m[i]=new Mono6();
	    Q.m[i].c=new BigInteger("0");
	    Q.m[i].e=LIST[i];
	    for(int j=0;j<P.count;++j) {
		if(match(P.m[j].e,LIST[i])==true) {
		    Q.m[i].c=Q.m[i].c.add(P.m[j].c);
		}
	    }
	}
	return(Q);
    }

    public static int[][] coeffList(Poly6 P) {
	int[][] LIST=new int[P.count][6];
	int c=0;
	for(int i=0;i<P.count;++i) {
	    if(onList(P.m[i].e,LIST,c)==false) {
		LIST[c]=P.m[i].e;
		++c;
	    }
	}
	int[][] LIST2=new int[c][6];
	for(int i=0;i<c;++i) LIST2[i]=LIST[i];
	return(LIST2);
    }


    /**These routines work for both poly5s and poly6s*/

    public static boolean match(int[] a,int[] b) {
	if(a.length!=b.length) return(false);
	for(int i=0;i<a.length;++i) {
	    if(a[i]!=b[i]) return(false);
	}
	return(true);
    }


    public static boolean onList(int[] a,int[][] LIST,int count) {
	for(int i=0;i<count;++i) {
	    if(match(a,LIST[i])==true) return(true);
	}
	return(false);
    }


}

